# -*- coding: utf-8 -*-
import sys, re, json, hashlib
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen, Request
except ImportError:
    from urllib.request import urlopen, Request
try:
    from urlparse import urlparse, parse_qs, urljoin
except ImportError:
    from urllib.parse import urlparse, parse_qs, urljoin
ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/87.0.4280.88 Safari/537.36'


def getsoup(url):
    request = Request(url, headers={'User-Agent': ua})
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(urlopen(request), 'html.parser')
    return BeautifulSoup(urlopen(request), 'html5lib')


def gethttp(url, headers={}):
    headers['User-Agent'] = ua
    request = Request(url, headers=headers)
    return urlopen(request).read().decode('utf-8')


def movies(url):
    try:
        content = gethttp(url)
    except Exception as e:
        return {'code': 'jav555 100', 'error': str(e)}
    uuid = re.search(r'<input id="uuid" type="hidden" value="(.*?)"/>', content)
    if not uuid:
        return {'code': 'jav555 101'}
    uuid = uuid.group(1)
    r = '586zhd'
    m = hashlib.md5((uuid + r + '9826avgbi63m498vdshxkn9852').encode('utf-8')).hexdigest()
    url1 = 'http://www3.jav555.me/ajax/get_sources/%s/%s?count=1' % (uuid, m)
    headers = {
        'X-Requested-With': 'XMLHttpRequest',
        'Cookie': '826avrbi6m49vd7shxkn985m' + uuid + 'k06twz87wwxtp3dqiicks2df=' + r
    }
    try:
        content1 = gethttp(url1, headers=headers)
    except Exception as e:
        return {'code': 'jav555 102', 'error': str(e)}
    try:
        data = json.loads(content1)
    except Exception as e:
        return {'code': 'jav555 103', 'error': str(e)}
    ret = []
    for e1 in data['playlist']:
        if 'sources' not in e1:
            continue
        for e2 in e1['sources']:
            ret.append({e2['label']: e2['file']})
    return ret


def studio(url, page=1):
    try:
        soup = getsoup('%s/page-%d' % (url, page))
    except Exception as e:
        return {'code': 'jav555 200', 'error': str(e)}
    ret = []
    try:
        for e1 in soup.select('div.movies-list div.ml-item a'):
            if 'href' not in e1.attrs:
                continue
            img = e1.img['data-original']
            img = urljoin(url, img)
            ret.append({'title': e1['title'], 'url': urljoin(url, e1['href']), 'img': img})
    except Exception as e:
        return {'code': 'jav555 201', 'error': str(e)}
    ret.append({'title': 'Next Page (%d)' % (page + 1), 'url': url, 'page': page + 1})
    return ret

def studios():
    url = 'http://www3.jav555.me/'
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'jav555 300', 'error': str(e)}
    ret = []
    try:
        for e in soup.select('ul.sub-menu li a'):
            if 'href' not in e.attrs:
                continue
            ret.append({e.text: urljoin(url, e['href'])})
    except Exception as e:
        return {'code': 'jav555 301', 'error': str(e)}
    return ret
